VTK: vtkGaussianKernel Class Reference

| VTK 9.3.1

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkGaussianKernel Class Reference

a spherical Gaussian interpolation kernel More...

`#include <vtkGaussianKernel.h>`

Inheritance diagram for vtkGaussianKernel:
[legend]
Collaboration diagram for vtkGaussianKernel:
[legend]

## Public Member Functions
void | Initialize (vtkAbstractPointLocator *loc, vtkDataSet *ds, vtkPointData *pd) override
| Initialize the kernel. More...
vtkIdType | ComputeWeights (double x[3], vtkIdList *pIds, vtkDoubleArray *prob, vtkDoubleArray *weights) override
| Given a point x, a list of basis points pIds, and a probability weighting function prob, compute interpolation weights associated with these basis points. More...
virtual vtkIdType | ComputeWeights (double x[3], vtkIdList *pIds, vtkDoubleArray *prob, vtkDoubleArray *weights)=0
| Given a point x, a list of basis points pIds, and a probability weighting function prob, compute interpolation weights associated with these basis points. More...
vtkIdType | ComputeWeights (double x[3], vtkIdList *pIds, vtkDoubleArray *weights) override
| Given a point x, and a list of basis points pIds, compute interpolation weights associated with these basis points. More...
virtual void | SetSharpness (double)
| Set / Get the sharpness (i.e., falloff) of the Gaussian. More...
virtual double | GetSharpness ()
| Set / Get the sharpness (i.e., falloff) of the Gaussian. More...
Public Member Functions inherited from vtkGeneralizedKernel
vtkIdType | ComputeBasis (double x[3], vtkIdList *pIds, vtkIdType ptId=0) override
| Based on the kernel style, invoke the appropriate locator method to obtain the points making up the basis. More...
vtkIdType | ComputeWeights (double x[3], vtkIdList *pIds, vtkDoubleArray *weights) override
| Given a point x, and a list of basis points pIds, compute interpolation weights associated with these basis points. More...
virtual void | SetKernelFootprint (int)
| Specify the interpolation basis style. More...
virtual int | GetKernelFootprint ()
| Specify the interpolation basis style. More...
void | SetKernelFootprintToRadius ()
| Specify the interpolation basis style. More...
void | SetKernelFootprintToNClosest ()
| Specify the interpolation basis style. More...
virtual void | SetRadius (double)
| If the interpolation basis style is Radius, then this method specifies the radius within which the basis points must lie. More...
virtual double | GetRadius ()
| If the interpolation basis style is Radius, then this method specifies the radius within which the basis points must lie. More...
virtual void | SetNumberOfPoints (int)
| If the interpolation basis style is NClosest, then this method specifies the number of the closest points used to form the interpolation basis. More...
virtual int | GetNumberOfPoints ()
| If the interpolation basis style is NClosest, then this method specifies the number of the closest points used to form the interpolation basis. More...
virtual void | SetNormalizeWeights (bool)
| Indicate whether the interpolation weights should be normalized after they are computed. More...
virtual bool | GetNormalizeWeights ()
| Indicate whether the interpolation weights should be normalized after they are computed. More...
virtual void | NormalizeWeightsOn ()
| Indicate whether the interpolation weights should be normalized after they are computed. More...
virtual void | NormalizeWeightsOff ()
| Indicate whether the interpolation weights should be normalized after they are computed. More...
vtkGeneralizedKernel * | NewInstance () const
| Standard methods for type and printing. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for type and printing. More...
Public Member Functions inherited from vtkInterpolationKernel
| vtkAbstractTypeMacro (vtkInterpolationKernel, vtkObject)
| Standard method for type and printing. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard method for type and printing. More...
virtual void | SetRequiresInitialization (bool)
| Indicate whether the kernel needs initialization. More...
virtual bool | GetRequiresInitialization ()
| Indicate whether the kernel needs initialization. More...
virtual void | RequiresInitializationOn ()
| Indicate whether the kernel needs initialization. More...
virtual void | RequiresInitializationOff ()
| Indicate whether the kernel needs initialization. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Protected Member Functions
| vtkGaussianKernel ()
| ~vtkGaussianKernel () override
Protected Member Functions inherited from vtkGeneralizedKernel
| vtkGeneralizedKernel ()
| ~vtkGeneralizedKernel () override
Protected Member Functions inherited from vtkInterpolationKernel
| vtkInterpolationKernel ()
| ~vtkInterpolationKernel () override
virtual void | FreeStructures ()
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | Sharpness
double | F2
Protected Attributes inherited from vtkGeneralizedKernel
int | KernelFootprint
double | Radius
int | NumberOfPoints
bool | NormalizeWeights
Protected Attributes inherited from vtkInterpolationKernel
bool | RequiresInitialization
vtkAbstractPointLocator * | Locator
vtkDataSet * | DataSet
vtkPointData * | PointData
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkGeneralizedKernel | Superclass
| Standard methods for instantiation, obtaining type information, and printing. More...
static vtkGaussianKernel * | New ()
| Standard methods for instantiation, obtaining type information, and printing. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instantiation, obtaining type information, and printing. More...
static vtkGaussianKernel * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instantiation, obtaining type information, and printing. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for instantiation, obtaining type information, and printing. More...
vtkGaussianKernel * | NewInstance () const
| Standard methods for instantiation, obtaining type information, and printing. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instantiation, obtaining type information, and printing. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for instantiation, obtaining type information, and printing. More...

## Additional Inherited Members
Public Types inherited from vtkGeneralizedKernel
enum | KernelStyle { RADIUS = 0 , N_CLOSEST = 1 }
| Enum used to select the interpolation basis form. More...
typedef vtkInterpolationKernel | Superclass
| Standard methods for type and printing. More...
Static Public Member Functions inherited from vtkGeneralizedKernel
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for type and printing. More...
static vtkGeneralizedKernel * | SafeDownCast (vtkObjectBase *o)
| Standard methods for type and printing. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

a spherical Gaussian interpolation kernel

vtkGaussianKernel is an interpolation kernel that simply returns the weights for all points found in the sphere defined by radius R. The weights are computed as: exp(-(s*r/R)^2) where r is the distance from the point to be interpolated to a neighboring point within R. The sharpness s simply affects the rate of fall off of the Gaussian. (A more general Gaussian kernel is available from vtkEllipsoidalGaussianKernel.)

Warning
  The weights are normalized sp that SUM(Wi) = 1. If a neighbor point p precisely lies on the point to be interpolated, then the interpolated point takes on the values associated with p.

See also
  vtkPointInterpolator vtkInterpolationKernel vtkEllipsoidalGaussianKernel vtkVoronoiKernel vtkSPHKernel vtkShepardKernel

Online Examples:

Tests:
  vtkGaussianKernel (Tests)

Definition at line 47 of file vtkGaussianKernel.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkGeneralizedKernel vtkGaussianKernel::Superclass

Standard methods for instantiation, obtaining type information, and printing.

Definition at line 55 of file vtkGaussianKernel.h.

## Constructor & Destructor Documentation

## ◆ vtkGaussianKernel()

vtkGaussianKernel::vtkGaussianKernel | ( |  | ) |
| protected

## ◆ ~vtkGaussianKernel()

vtkGaussianKernel::~vtkGaussianKernel | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkGaussianKernel* vtkGaussianKernel::New | ( |  | ) |
| static

Standard methods for instantiation, obtaining type information, and printing.

## ◆ IsTypeOf()

static vtkTypeBool vtkGaussianKernel::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods for instantiation, obtaining type information, and printing.

## ◆ IsA()

virtual vtkTypeBool vtkGaussianKernel::IsA | ( | const char * | type | ) |
| virtual

Standard methods for instantiation, obtaining type information, and printing.

Reimplemented from vtkGeneralizedKernel.

## ◆ SafeDownCast()

static vtkGaussianKernel* vtkGaussianKernel::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods for instantiation, obtaining type information, and printing.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkGaussianKernel::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for instantiation, obtaining type information, and printing.

Reimplemented from vtkGeneralizedKernel.

## ◆ NewInstance()

vtkGaussianKernel* vtkGaussianKernel::NewInstance | ( |  | ) | const

Standard methods for instantiation, obtaining type information, and printing.

## ◆ PrintSelf()

void vtkGaussianKernel::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods for instantiation, obtaining type information, and printing.

Reimplemented from vtkObject.

## ◆ Initialize()

void vtkGaussianKernel::Initialize | ( | vtkAbstractPointLocator * | loc,
|  | vtkDataSet * | ds,
|  | vtkPointData * | pd
| ) |  |
| overridevirtual

Initialize the kernel.

Overload the superclass to set up internal computational values.

Reimplemented from vtkInterpolationKernel.

## ◆ ComputeWeights() [1/3]

vtkIdType vtkGaussianKernel::ComputeWeights | ( | double | x[3],
|  | vtkIdList * | pIds,
|  | vtkDoubleArray * | prob,
|  | vtkDoubleArray * | weights
| ) |  |
| overridevirtual

Given a point x, a list of basis points pIds, and a probability weighting function prob, compute interpolation weights associated with these basis points.

Note that basis points list pIds, the probability weighting prob, and the weights array are provided by the caller of the method, and may be dynamically resized as necessary. The method returns the number of weights (pIds may be resized in some cases). Typically this method is called after ComputeBasis(), although advanced users can invoke ComputeWeights() and provide the interpolation basis points pIds directly. The probably weighting prob are numbers 0<=prob<=1 which are multiplied against the interpolation weights before normalization. They are estimates of local confidence of weights. The prob may be nullptr in which all probabilities are considered =1.

Implements vtkGeneralizedKernel.

## ◆ SetSharpness()

virtual void vtkGaussianKernel::SetSharpness | ( | double |  | ) |
| virtual

Set / Get the sharpness (i.e., falloff) of the Gaussian.

By default Sharpness=2. As the sharpness increases the effects of distant points are reduced.

## ◆ GetSharpness()

virtual double vtkGaussianKernel::GetSharpness | ( |  | ) |
| virtual

Set / Get the sharpness (i.e., falloff) of the Gaussian.

By default Sharpness=2. As the sharpness increases the effects of distant points are reduced.

## ◆ ComputeWeights() [2/3]

virtual vtkIdType vtkGeneralizedKernel::ComputeWeights

Given a point x, a list of basis points pIds, and a probability weighting function prob, compute interpolation weights associated with these basis points.

Note that basis points list pIds, the probability weighting prob, and the weights array are provided by the caller of the method, and may be dynamically resized as necessary. The method returns the number of weights (pIds may be resized in some cases). Typically this method is called after ComputeBasis(), although advanced users can invoke ComputeWeights() and provide the interpolation basis points pIds directly. The probably weighting prob are numbers 0<=prob<=1 which are multiplied against the interpolation weights before normalization. They are estimates of local confidence of weights. The prob may be nullptr in which all probabilities are considered =1.

## ◆ ComputeWeights() [3/3]

vtkIdType vtkGeneralizedKernel::ComputeWeights
| inlineoverride

Given a point x, and a list of basis points pIds, compute interpolation weights associated with these basis points.

Note that both the nearby basis points list pIds and the weights array are provided by the caller of the method, and may be dynamically resized as necessary. Typically this method is called after ComputeBasis(), although advanced users can invoke ComputeWeights() and provide the interpolation basis points pIds directly.

Definition at line 107 of file vtkGeneralizedKernel.h.

## Member Data Documentation

## ◆ Sharpness

double vtkGaussianKernel::Sharpness
| protected

Definition at line 99 of file vtkGaussianKernel.h.

## ◆ F2

double vtkGaussianKernel::F2
| protected

Definition at line 102 of file vtkGaussianKernel.h.

The documentation for this class was generated from the following file:

- Filters/Points/vtkGaussianKernel.h